/**
 ***********************************************************************
 * $Id: Token.cs 330 2015-01-06 08:08:07Z mkwayisi $
 * ---------------------------------------------------------------------
 * Authored by Michael Kwayisi. Copyright (c) 2014. See license below.
 * Comments are appreciated - mic at kwayisi dot org | www.kwayisi.org
 * ---------------------------------------------------------------------
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are stringently met:
 *  1. Redistributions of source code must retain the above copyright
 *     notice, this list of conditions, and the following disclaimer.
 *  2. Redistributions in binary form must reproduce the above
 *     copyright notice, this list of conditions, and the following
 *     disclaimer in the documentation and/or other materials provided
 *     with the distribution.
 *  3. The end-user documentation included with the redistribution,
 *     if any, must include the following acknowledgment:
 *       "This product includes software written by Michael Kwayisi."
 *     Alternately, this acknowledgment may appear in the software
 *     itself, if and wherever such 3rd-party acknowledgments appear.
 *  4. Neither the name of the software nor the name of its author
 *     and/or contributors may be used to endorse or promote products
 *     derived from this software without specific prior permission.
 ***********************************************************************
 */

using System;
using System.Drawing;
using System.Threading;

public class Token : Control
{
//======================================================================
// [DATA] Class instance data fields.
public  int CellID = 0;
private int @value = 0;

//======================================================================
// [PROP] Value - Gets or sets the value for this "token".
public int Value {
	get {
		return this.@value;
	}
	set {
		this.@value = value;
		this.text = Lib.GetTokenMap(value);
	}
}

//======================================================================
// [FUNC] Primary class instance constructor.
public Token()
{
	this.Size = new Size(10, 7);
	this.Padding = new Point(1, 0);
	this.BorderStyle = BorderStyle.DoubleCorners;
}

//======================================================================
// [FUNC] Draws the border of this "Token".
public void DrawBorder()
{
	base.drawBorder();
}

//======================================================================
// [FUNC] Displays this "Token" on-screen with an option to animate.
public void Show(bool animate)
{
	Console.ForegroundColor = this.ForeColor;
	for (int i = 0; i < this.text.Length; i++) {
		Console.SetCursorPosition(this.Location.X + this.Padding.X + 1,
			this.Location.Y + this.Padding.Y + i + 1);
		for (int j = 0; j < this.text[i].Length; j++) {
			Console.Write(this.text[i][j] == '1' ? Program.TokenMagicChar : ' ');
			if (animate && j == 0)
				Thread.Sleep(10);
		}
	}
}
}
